﻿using System;
using Android.App;
using Android.Content;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Android.OS;
using Com.Cipherlab.Rfidapi;
using Com.Cipherlab.Rfid;
using Android.Util;
using System.Collections.Generic;
using Java.Util;
using System.Collections;

namespace XamarinExample
{
    [Activity(Label = "XamarinExample", MainLauncher = true, Icon = "@drawable/icon")]
    public class MainActivity : Activity
    {
        //int count = 1;

        static RfidManager m_RM = null;
        static TextView Scan_Data;
        static String sDataStr = "";
        private IntentFilter filter;
        private DataReceiver myDataReceiver;
        static Spinner spinner;
        int Beep_item = -1;
        static String TAG = "RFID_sample";

        protected override void OnCreate(Bundle bundle)
        {
            base.OnCreate(bundle);
           
            // Reader InitInstance
            m_RM = RfidManager.InitInstance(this);
            myDataReceiver = new DataReceiver();

            filter = new IntentFilter();
            filter.AddAction(GeneralString.IntentRFIDSERVICECONNECTED);
            filter.AddAction(GeneralString.IntentRFIDSERVICETAGDATA);
            RegisterReceiver(myDataReceiver, filter);

            // Set our view from the "main" layout resource
            SetContentView(Resource.Layout.Main);

            // Get our button from the layout resource,
            // and attach an event to it
            Button button = FindViewById<Button>(Resource.Id.MyButton);
            button.Click += delegate 
            {
                
                //button.Text = string.Format("{0} clicks!", count++);
                NotificationParams settings_NotificationParams = new NotificationParams();
                m_RM.GetNotification(settings_NotificationParams);
                if (Beep_item == 0)
                    settings_NotificationParams.ReaderBeep = BeepType.Mute;
                else if (Beep_item == 1)
                    settings_NotificationParams.ReaderBeep = BeepType.Default;
                else if (Beep_item == 2)
                    settings_NotificationParams.ReaderBeep = BeepType.Ringtone1;
                else if (Beep_item == 3)
                    settings_NotificationParams.ReaderBeep = BeepType.Ringtone2;
                else if (Beep_item == 4)
                    settings_NotificationParams.ReaderBeep = BeepType.Ringtone3;
                else if (Beep_item == 5)
                    settings_NotificationParams.ReaderBeep = BeepType.Ringtone4;

                if (ClResult.SOk.Ordinal() != m_RM.SetNotification(settings_NotificationParams))
                {
                    String err = m_RM.LastError;
                    Toast.MakeText(this, "Set_NotificationParams was failed : " + err, ToastLength.Short).Show();
                }
                    
                else
                    Toast.MakeText(this, "Set_NotificationParams was successful", ToastLength.Short).Show();
            };

            Button button_scan = FindViewById<Button>(Resource.Id.button1);
            button_scan.Click += delegate {

                if (m_RM.ConnectionStatus)
                {
                    DeviceInfo info = m_RM.DeviceInfo;
                    Log.Debug(TAG, "deviceInfo.SerialNumber = " + info.SerialNumber);
                    Log.Debug(TAG, "deviceInfo.Region = " + info.Region);
                    Log.Debug(TAG, "deviceInfo.KernelVersion = " + info.KernelVersion);
                    Log.Debug(TAG, "deviceInfo.UserVersion = " + info.UserVersion);
                    Log.Debug(TAG, "deviceInfo.RFIDModuleVersion = " + info.RFIDModuleVersion);

                    //m_RM.SetPowerMode(PowerMode.Normal);
                    //PowerMode mode = m_RM.PowerMode;

                    //AllQValue q = new AllQValue();
                    //int  re = m_RM.GetAllQValue(q);
                    //IEnumerator enumerator = q.QAll.GetEnumerator();

                    //while (enumerator.MoveNext())
                    //{
                    //    Console.WriteLine(enumerator.Current);
                    //    QValue em123 = new QValue();
                    //    em123 = (QValue)enumerator.Current;
                    //    Log.Debug(TAG, "Dynamic = " + em123.Dynamic);
                    //    Log.Debug(TAG, "Max = " + em123.Max);
                    //    Log.Debug(TAG, "Min = " + em123.Min);
                    //    Log.Debug(TAG, "Value = " + em123.Value);
                    //}


                    //AllRFLink RF = new AllRFLink();
                    //re = m_RM.GetAllRFLink(RF);
                    //RF.RFLinkAll.RemoveAt(WorkMode.UserDefine2.Ordinal());
                    //RF.RFLinkAll.Insert(WorkMode.UserDefine2.Ordinal(), RFLink.PRASKMiller4300KHz.Ordinal());
                    
                    //re = m_RM.SetAllRFLink(RF);
                    //if (re != ClResult.SOk.Ordinal())
                    //{
                    //    String m = m_RM.LastError;
                    //    Log.Debug(TAG, "LastError = " + m);
                    //}
                    //else
                    //    Log.Debug(TAG, "SetAllRFLink is successful.");

                    //IEnumerator enumerator_RF = RF.RFLinkAll.GetEnumerator();
                    //while (enumerator_RF.MoveNext())
                    //{
                    //    Log.Debug(TAG, "enumerator_RF = " + (int)enumerator_RF.Current);

                    //    if ((int)enumerator_RF.Current == RFLink.DSBASKFM040KHz.Value)
                    //    {
                    //    }

                    //}



                }
                else
                    Toast.MakeText(this, "The GUN Unattached", ToastLength.Short).Show();


            };

            Scan_Data = FindViewById<TextView>(Resource.Id.textView1);

            spinner = this.FindViewById<Spinner>(Resource.Id.spinner1);
            var adapter = ArrayAdapter.CreateFromResource(
                this, Resource.Array.planets_array, Android.Resource.Layout.SimpleSpinnerItem);

            adapter.SetDropDownViewResource(Android.Resource.Layout.SimpleSpinnerDropDownItem);
            spinner.Adapter = adapter;

            spinner.ItemSelected += (sender, e) =>
            {
                var s = sender as Spinner;
                Beep_item = e.Position;
                //Toast.MakeText(this, "My Bepper is " + s.GetItemAtPosition(e.Position), ToastLength.Short).Show();
            };
        }

        static void display(IEnumerator<QValue> em)
        {
            while (em.MoveNext())
            {
                QValue val = em.Current;
                Log.Debug(TAG, "Value = " + val.Value);
                Log.Debug(TAG, "Dynamic = " + val.Dynamic);
                Log.Debug(TAG, "Max = " + val.Max);
                Log.Debug(TAG, "Min = " + val.Min);
                //Console.WriteLine(val);
            }
        }

        protected override void OnDestroy()
        {
            base.OnDestroy();

            // ***************************************************//
            // 在關閉此APP前可以先註銷之前的Broadcast Receiver
            // ***************************************************//
            UnregisterReceiver(myDataReceiver);

            // Reader Release
            m_RM.Release();
        }

        /// 產生一個broadcast 物件，用來接收service丟過來的intent
		class DataReceiver : BroadcastReceiver
        {
            public override void OnReceive(Context context, Android.Content.Intent intent)
            {
                // 如果收到Intent_SOFTTRIGGER_DATA這個字串的intent的話
                if (intent.Action == GeneralString.IntentRFIDSERVICETAGDATA)
                {
                    sDataStr = "";
                    // 把intent裡夾帶的資料取出來

                    int type = intent.GetIntExtra(GeneralString.ExtraDataType, -1);
                    int response = intent.GetIntExtra(GeneralString.ExtraResponse, -1);
                    double data_rssi = intent.GetDoubleExtra(GeneralString.ExtraDataRssi, 0);

                    String PC = intent.GetStringExtra(GeneralString.ExtraPc);
                    String EPC = intent.GetStringExtra(GeneralString.ExtraEpc);
                    String TID = intent.GetStringExtra(GeneralString.ExtraTid);
                    String ReadData = intent.GetStringExtra(GeneralString.EXTRAReadData);
                    int EPC_length = intent.GetIntExtra(GeneralString.ExtraEpcLength, 0);
                    int TID_length = intent.GetIntExtra(GeneralString.ExtraTidLength, 0);
                    int ReadData_length = intent.GetIntExtra(GeneralString.EXTRAReadDataLENGTH, 0);

                    Log.Debug(TAG, "++++ [Intent_RFIDSERVICE_TAG_DATA] ++++");
                    Log.Debug(TAG, "[Intent_RFIDSERVICE_TAG_DATA] type=" + type + ", response=" + response + ", data_rssi=" + data_rssi);
                    Log.Debug(TAG, "[Intent_RFIDSERVICE_TAG_DATA] PC=" + PC);
                    Log.Debug(TAG, "[Intent_RFIDSERVICE_TAG_DATA] EPC=" + EPC);
                    Log.Debug(TAG, "[Intent_RFIDSERVICE_TAG_DATA] EPC_length=" + EPC_length);
                    Log.Debug(TAG, "[Intent_RFIDSERVICE_TAG_DATA] TID=" + TID);
                    Log.Debug(TAG, "[Intent_RFIDSERVICE_TAG_DATA] TID_length=" + TID_length);
                    Log.Debug(TAG, "[Intent_RFIDSERVICE_TAG_DATA] ReadData=" + ReadData);
                    Log.Debug(TAG, "[Intent_RFIDSERVICE_TAG_DATA] ReadData_length=" + ReadData_length);

                    Scan_Data.Text += EPC + "\n";
                }

                else if (intent.Action == GeneralString.IntentRFIDSERVICECONNECTED)
                {
                    String packname = intent.GetStringExtra("PackageName");
                    String ver = "";
                    ver = m_RM.ServiceVersion;
                    String api_ver = m_RM.APIVersion;
                    Log.Debug(TAG, "ServiceVersion = " + ver + " , APIVersion = " + api_ver);

                    NotificationParams gettings_NotificationParams = new NotificationParams();
                    m_RM.GetNotification(gettings_NotificationParams);
                    if (gettings_NotificationParams.ReaderBeep == BeepType.Mute)
                        spinner.SetSelection(0);
                    else if (gettings_NotificationParams.ReaderBeep == BeepType.Default)
                        spinner.SetSelection(1);
                    else if (gettings_NotificationParams.ReaderBeep == BeepType.Ringtone1)
                        spinner.SetSelection(2);
                    else if (gettings_NotificationParams.ReaderBeep == BeepType.Ringtone2)
                        spinner.SetSelection(3);
                    else if (gettings_NotificationParams.ReaderBeep == BeepType.Ringtone3)
                        spinner.SetSelection(4);
                    else if (gettings_NotificationParams.ReaderBeep == BeepType.Ringtone4)
                        spinner.SetSelection(5);
                }
            }
        }
    }
}

